/******************************(i2c_EEPROM.c)***************
 *	I2CڑEEPROM(24FC1025)ǂݏCu
 ***********************************************************/

#define DEVICE	0x50                    // Blk0=0x50,Blk1=0x54
#define MBFSIZE	78                      // pobt@[TCY

#include "i2cEEPROM.h"

//=== O[oϐ ============
char     Dlm[] = ",";                   // ؂f~^
char     SBuf[20];                      // 񏈗pobt@[

//--- I2C[p
static uint8_t  BlkNum = 0;             // ubNԍ
static uint16_t CrtAdr = 0;             // JgAhX
static uint8_t  DBuf[MBFSIZE];          // y[Wpobt@[
static uint8_t  SqMode = 0;             // V[PX[htO
static char     lstCmd;                 // ŏIR}h

/*************************************
 *  I2C EEPROM function
 **************************************/
//-----  AhXadrA1oCgǂݏo
uint8_t I2C_Mem_Read(uint16_t adr){
    uint8_t bf[2];

    bf[0] = adr >> 8;
    bf[1] = (uint8_t)adr;
    #if I2C == 1
        I2C1_WriteNBytes(DEVICE + BlkNum,bf,2);
        I2C1_ReadNBytes(DEVICE + BlkNum,bf,1);
    #elif I2C == 2
        I2C2_WriteNBytes(DEVICE + BlkNum,bf,2);
        I2C2_ReadNBytes(DEVICE + BlkNum,bf,1);
    #else
        I2C_WriteNBytes(DEVICE + BlkNum,bf,2);
        I2C_ReadNBytes(DEVICE + BlkNum,bf,1);
    #endif
    return bf[0];
}

//-----  AhXadrɁA1oCgdt
void I2C_Mem_Write(uint16_t adr, uint8_t dt){
    uint8_t bf[3];

    bf[0] = adr >> 8;
    bf[1] = (uint8_t)adr;               // AhXZbg
    bf[2] = dt;                         // f[^Zbg
    #if I2C == 1
        I2C1_WriteNBytes(DEVICE + BlkNum,bf,3);  //
    #elif I2C == 2
        I2C2_WriteNBytes(DEVICE + BlkNum,bf,3); 
    #else
        I2C_WriteNBytes(DEVICE + BlkNum,bf,3); 
    #endif
    __delay_ms(5);
}

//-----  AhXadr炎oCgary[]ɓǂݏo
void I2C_Mem_NRead(uint16_t adr, uint8_t *ary, uint8_t n){
    uint8_t bf[2];

    bf[0] = adr >> 8;
    bf[1] = (uint8_t) adr;
    if(n > MBFSIZE) n = MBFSIZE;        // zvfȓ
    #if I2C == 1
        I2C1_WriteNBytes(DEVICE+BlkNum,bf,2);  // AhXM
        I2C1_ReadNBytes(DEVICE+BlkNum,ary,n);  // f[^Ǎ
    #elif I2C == 2
        I2C2_WriteNBytes(DEVICE+BlkNum,bf,2);  // AhXM
        I2C2_ReadNBytes(DEVICE+BlkNum,ary,n);  // f[^Ǎ
    #else
        I2C_WriteNBytes(DEVICE+BlkNum,bf,2);  // AhXM
        I2C_ReadNBytes(DEVICE+BlkNum,ary,n);  // f[^Ǎ    
    #endif
}

//-----  AhXadrary[]noCg
void I2C_Mem_NWrite(uint16_t adr, uint8_t  *ary, uint8_t n){
    uint8_t bf[MBFSIZE + 2];

    bf[0] = adr >> 8;                   // AhXZbg
    bf[1] = (uint8_t) adr;              // y[WEɒӁI
    if(n > MBFSIZE) n = MBFSIZE;
    memcpy(bf+2,ary,n);                 // ary[]bf[]ɃRs[
    #if I2C == 1
        I2C1_WriteNBytes(DEVICE+BlkNum,bf,n+2);
    #elif I2C == 2
        I2C2_WriteNBytes(DEVICE+BlkNum,bf,n+2);
    #else
        I2C_WriteNBytes(DEVICE+BlkNum,bf,n+2);
    #endif
        __delay_ms(5);
}

//---- y[Wobt@[vg
void prt_PBf(){
    uint8_t i;
    for(i = 0; i < 64; i++){            // 164\
		#ifdef VBA
        	if(i % 16 == 0) printf("\r");
		#else
        	if(i % 16 == 0) printf("\n\r");
        #endif
        printf(" %02X",DBuf[i]);
    }
    puts("\r");
}

//---- 16i10iɕϊ
int32_t my_xtoi(char *str){
    uint32_t dec;

    dec = strtoul(str,NULL,16);
//    if(errno == ERANGE) return -1;      // ϊG[
    return (int32_t)dec;
}

/************************************
 * 	R}hANV
 ************************************/
//----- vR}h   W[aaaa][,[d0,[,]]]
uint16_t i2cRom_cmd_W(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  last;                      // ̍Ō̈ʒu
    int32_t  res = 0;                   // Hexlϊ
    uint8_t  dt = 0;                    // ރoCgf[^
    uint16_t cnt = 0;                   // ۂɏ񂾃oCg

    lstCmd = str[0];
    if(strlen(str)==1){                 // 'W'݂̂Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        return 0;                       // f[^͏܂Ȃ
    }
    last = (uint8_t)strlen(str)-1;      // ̍sʒu擾
    if(str[last] == ','){               // sR}Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        str[last]='\0';                 // s̃R}
    }
    if(str[1]!=','){                    // 2R}H
        pt = strtok(str+1,Dlm);         // R}h̎
        if(pt != NULL){                 // AhXf[^
            res = my_xtoi(pt);
//            if(res < 0) return cnt;     // ϊG[
            CrtAdr = (uint16_t)res;
        }
        pt = strtok(NULL,Dlm);          // 捞
    }else{
        pt = strtok(str+1,Dlm);         // 捞
    } 
    do{
        if(pt != NULL){                 // f[^邩H
            res = my_xtoi(pt);
            if(res < 0) return cnt;
            dt = (uint8_t)res;
            if(lstCmd=='W'){
                I2C_Mem_Write(CrtAdr,dt);   // f[^
            }else if(lstCmd == 'S'){
			    DBuf[CrtAdr & 0x3F]= dt;  
            }
            sprintf(SBuf,"%d:%04X < %02X",BlkNum,CrtAdr,dt);
            #ifdef VBA
                printf("%s\r",SBuf);
            #else
                printf("%s\n\r",SBuf);
            #endif            
            LCD_cursor(1,1); LCD_str(SBuf);
            CrtAdr++; cnt++;          
            pt = strtok(NULL,Dlm);      // 
        }
    }while(pt != NULL);                 // f[^邾JԂ
    return cnt;                         // 񂾕Ԃ
}

//---- qR}h  R[aaaa][,n]
uint16_t i2cRom_cmd_R(char *str){
    char *pt;                           // 񑀍p|C^
    uint16_t n = 1;                     // w肳ꂽǍoCg
    int32_t  res = 0;                   // Hexlϊ
    uint8_t  dt;                        // ǂݍ񂾃oCgf[^
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg
    uint8_t  i;                         // [vϐ

    lstCmd = str[0];
    if(strlen(str) > 1){
        if(str[1]==','){
            pt = strtok(str+2,Dlm);
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
//                if((res < 0)|(res>0xFF)) return cnt;
                n = (uint16_t)res;
            }
        }else{
            pt = strtok(str+1,Dlm);
            if(pt != NULL){             // address?
                res = my_xtoi(pt);
//                if(res < 0) return cnt; // ϊG[
                CrtAdr = (uint16_t)res;
            }
            pt = strtok(NULL,Dlm);      // 
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
//                if(res < 0) return cnt;
                n = (uint16_t)res;
            }
        }
    }
    for(i = 0; i < n;i++ ){
        dt = I2C_Mem_Read(CrtAdr);      // f[^ǂݏo
        sprintf(SBuf,"%d:%04X > %02X",BlkNum,CrtAdr,dt);
        #ifdef VBA
        	printf("%s\r",SBuf);
        #else
        	printf("%s\n\r",SBuf);
        #endif
        LCD_cursor(1,1); LCD_str(SBuf);
        CrtAdr++; cnt++;
    }
    SqMode = 0;
    return cnt;                         // ǂݍ񂾃f[^Ԃ
}

//---- WSQ iA[hj
uint16_t i2cRom_cmd_WSQ(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  dt;                        // ރoCgf[^
    int32_t  res;                       // Hexlϊ
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg

    pt = strtok(str,Dlm);
    while(pt != NULL){                  // f[^邾JԂ
        res = my_xtoi(pt);
//        if(res < 0) return cnt;         // ϊG[
        dt = (uint8_t)res;
        if(lstCmd == 'W'){
            I2C_Mem_Write(CrtAdr,dt);       // f[^
        }else if(lstCmd=='S'){
			DBuf[CrtAdr & 0x3F]= dt;  
        }    
        #ifdef VBA
        	printf("%d:%04X < %02X\r",BlkNum,CrtAdr,dt);
        #else
        	printf("%d:%04X < %02X\n\r",BlkNum,CrtAdr,dt);
        #endif
        CrtAdr++; cnt++;
        pt = strtok(NULL,Dlm);          // 
    }
    return cnt;                         // 񂾃f[^Ԃ
}

//---- MaR}h  MBn
int i2cRom_cmd_M(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  b;                         // oNԍ

    lstCmd = str[0];
    if(str[1] != 'B') return -1;        // 2BH
    pt = strtok(str+2,Dlm);
    if(pt==NULL) return -1;             // ϊG[
    b = atoi(pt) & 0x01;
    #ifdef VBA
    	printf("Bank %d selected\r",b);
    #else
    	printf("Bank %d selected\n\r",b);
    #endif
    BlkNum = b * 4;                     // Blk = bit2
    CrtAdr = 0;                         // ݃AhX0
    SqMode = 0;
//    puts("SqMode OFF\r");
    return b;
}

//---- pR}hiA[h̉j   Q
void i2cRom_cmd_Q(char *str){
    lstCmd = str[0];
	SqMode = 0;
	#ifndef VBA
		puts("SqMode OFF\r");
	#endif
}

//---- t(dump)R}h    U[aaaa]
//         i64oCg̃f[^DBuf[]ɓǂݏo)
int i2cRom_cmd_U(char *str){
    char    *pt;                        // 񑀍p|C^
    int32_t  res;                       // Hexlϊ
    uint16_t ad;                        // wAhX

    lstCmd = str[0];
    pt = strtok(str+1,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
//        if(res < 0) return -1;          // ϊG[
        CrtAdr = (uint16_t)res;
    }
    ad = CrtAdr & 0xFFC0;               // 64oCgPʂ 
    I2C_Mem_NRead(ad,DBuf,64);          // 64oCgDBuf[]ɓǏo
    printf("%d:%04X - %04X",BlkNum,ad,ad+63);
    prt_PBf();
    SqMode = 0;
    return 0;
}

//---- o(Page)R}h    PW[aaaa]
//          iDBuf[]64oCgɏށj
int i2cRom_cmd_P(char *str){
    char     *pt;                       // 񑀍p|C^
    int32_t  res;                       // Hexlϊ
    uint16_t ad;                        // wAhX

    lstCmd = str[0];
    if(strlen(str)==1){
        printf("PageBuffer");
        prt_PBf();
        return 0;
    }
    if(str[1]=='R'){
        i2cRom_cmd_U(str+1);
        return 0;
    }
    if(str[1] != 'W') return -1;        // 2vH
    pt = strtok(str+2,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
//        if(res < 0) return -1;          // ϊG[
        CrtAdr = (uint16_t)res;
    }
    ad = CrtAdr & 0xFFC0;               // 64oCgPʂ
    I2C_Mem_NWrite(ad,DBuf,64);         // DBuf[]64oCg
    #ifdef VBA
    	printf("Page Write %d:%04X - %04X\r",BlkNum,ad,ad+63);
    #else
    	printf("Page Write %d:%04X - %04X\n\r",BlkNum,ad,ad+63);
    #endif
    SqMode = 0;    
    return 0;
}

//----  V[PX[h̊mF
uint8_t i2cRom_SqMode(){
	return SqMode;
}
/******* End of File ********
